#include "unmap.h"
#include <stdio.h>
#include "aswm/log/log.h"
#include <X11/Xutil.h>

void OnUnmapNotify(Aswm* aswm, const XUnmapEvent* e) {
	printf("XUnmapWindow %lu tiled in %lu\n", e->window, e->event);
	XWMHints* hints = XGetWMHints(aswm->display, e->window);
	if(hints != NULL) {
		printf("\tWM_HINTS\n");
		printf("\t\tinitial_state: %i\n", hints->initial_state);
	}
	// Since SubstructureNotify is selected on each frame, e->event corresponds
	// to the parent of the unmapped window (e->window)

	// Unmap should have no effect on not map windows. Currently, all mapped
	// windows are children of aswm->root_window.
	if(e->event != XDefaultRootWindow(e->display)) {
		if(e->event == aswm->current_desktop.tile_root) {
			printf("aswm untile\n");
			aswm_untile_window(e->display, e->event, e->window);
		} else if(e->event == aswm->current_desktop.stack_root) {
			printf("aswm unstack\n");
			aswm_unstack_window(e->display, e->event);
		}
		printf("Unmap tree:\n");
		log_tree(aswm, DefaultRootWindow(aswm->display), 1);
	}
}
